unit Caerror;

{ by Paul Toth (TothPaul@mygale.org) }
{ http://www.mygale.org/~tothpaul    }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Resource, Buttons;

type
  ECawin=class(Exception)
  public
   Constructor CreateCAGet(Const ErrorType:string; ErrorLevel:integer);
   Constructor CreateCAShow(Const ErrorType:string; ErrorLevel:integer);
  end;

  TShowCAError = class(TForm)
    CaRes: TResource;
    ErrorType: TResCaption;
    ErrorLevel: TResCaption;
    BitBtn1: TBitBtn;
  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

var
  ShowCAError: TShowCAError;

Function ShowError(AErrorType:string; AErrorLevel:Word):string;
Function GetError(AErrorType:string; AErrorLevel:word):string;

implementation

{$R *.DFM}

constructor ECawin.CreateCAGet(Const ErrorType:string; ErrorLevel:integer);
 begin
  Message:=GetError(ErrorType,ErrorLevel);
 end;

constructor ECawin.CreateCAShow(Const ErrorType:string; ErrorLevel:integer);
 begin
  Message:=ShowError(ErrorType,ErrorLevel);
 end;

Function ShowError(AErrorType:string; AErrorLevel:word):string;
 begin
  With TShowCAError.Create(Application) do begin
   ErrorType.StringName:=AErrorType;
   ErrorLevel.StringName:=AErrorType+IntToHex(AErrorLevel,4);
   Screen.Cursor:=crDefault;
   Application.ProcessMessages;
   ShowModal;
   Result:=ErrorLevel.Caption;
   Free;
  end;
 end;

Function GetError(AErrorType:string; AErrorLevel:word):string;
 begin
  With TShowCAError.Create(Application) do begin
   ErrorType.StringName:=AErrorType;
   ErrorLevel.StringName:=AErrorType+IntToHex(AErrorLevel,4);
   Result:=ErrorLevel.Caption;
   Free;
  end;
 end;

end.
