unit Careg4;

{ by Paul Toth (TothPaul@mygale.org) }
{ http://www.mygale.org/~tothpaul    }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Call400, StdCtrls, Buttons;

type
  TParmsEditor = class(TForm)
    ParmList: TListBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    BitBtn1: TBitBtn;
    GroupBox1: TGroupBox;
    ParmName: TEdit;
    cInput: TRadioButton;
    cOutput: TRadioButton;
    cBoth: TRadioButton;
    Button1: TButton;
    ParmSize: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure ParmListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations private }
    fCall400:TCall400;
  public
    { Dclarations public }
    Procedure SetCall400(ACall400:TCall400);
  end;

var
  ParmsEditor: TParmsEditor;

Procedure EditParms(ACall400:TCall400);

implementation

{$R *.DFM}

procedure EditParms(ACall400:TCall400);
 begin
  With TParmsEditor.Create(Application) do begin
   SetCall400(ACall400);
   ShowModal;
   Free;
  end;
 end;

procedure TParmsEditor.SetCall400(ACall400:TCall400);
 var
  i:integer;
 begin
  fCall400:=ACall400;
  ParmList.Clear;
  for i:=0 to fCall400.ParmCount-1 do begin
   ParmList.Items.Add(fCall400.Parms[i].Name);
  end;
 end;

procedure TParmsEditor.Button1Click(Sender: TObject);
begin
{ validate name }
 if (ParmName.Text='')or(fCall400.FindParm(ParmName.text)<>nil) then begin
  ShowMessage('Invalid Name');
  ParmName.SelectAll;
  ParmName.SetFocus;
  exit;
 end;
{ create parm }
 with TParm400.Create(fCall400) do begin
  Name:=ParmName.Text;
  if cInput.Checked  then Access:=paInput;
  if cOutput.Checked then Access:=paOutput;
  if cBoth.Checked   then Access:=paBoth;
  Size:=StrToInt(ParmSize.Text);
 end;
{ add in list }
 ParmList.Items.Add(ParmName.Text);
{ clear parmname }
 ParmName.Text:='';
end;

procedure TParmsEditor.ParmListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=vk_delete then begin
  fCall400.Parms[ParmList.ItemIndex].Free;
  ParmList.Items.Delete(ParmList.ItemIndex);
 end;
end;

end.
